segment .data

  NL  db 13,10,0

segment .text

%stacksize flat

%include "nasm_macros.asm"

extern _cprintf
extern exit

global _manual, _auto

; Manual local variables
_manual:
    push ebp              ; preserve ebp before changing it
    mov ebp,esp           ; init ebp as stack frame pointer
    sub esp,8             ; reserve space for 2 local dwords

    mov [ebp-4],esi
    mov [ebp-8],edi
    mov esi,[ebp-8]
    mov edi,[ebp-4]

    mov esp,ebp           ; restore esp
    pop ebp               ; recover ebp
    ret

; Automatic local variables
_auto:
    %push currentcontext
    %assign %$localsize 0 ; must be defined in the current
                          ;  context to use %local
    %local local1:dword, local2:dword
      enter %$localsize,0
  
      mov [local1],esi
      mov [local2],edi
      mov esi,[local2]
      mov edi,[local1]
  
      leave
      ret
    %pop

Start:
    mov   esi,1234
    mov   edi,5678
    INVOKE _cprintf, "esi = %d edi = %d%s", esi, edi, NL
    add esp,16

    call _manual

    INVOKE _cprintf, "esi = %d edi = %d%s", esi, edi, NL
    add esp,16

    call _auto

    INVOKE _cprintf, "esi = %d edi = %d%s%s", esi, edi, NL, NL
    add esp,20

    INVOKE _cprintf, "Press any key to exit..."
    add esp,4

    PAUSE
    call exit
